﻿/*--------------------------------------------------------------
	ソードワールド2.0用抽象戦闘jQueryプラグイン

	マップ上にコマをドラッグ可能なコマを配置し、移動および乱戦エリアを管理する。

	開発・制作		tori
	動作環境		jQuery3.x	
	
	TODO：マップ上に
--------------------------------------------------------------*/
//google.load('jquery', '1');google.load("jqueryui", "1");
var unit_size=32;//移動力1あたりのピクセル数。
var undo_count=10;//undo/redo回数。
(function($){//ｊQuery
	//マップ上に置くコマ piece
	
	    // 全メソッドをここに定義
    var piecemethods = {
        init    : function(params){
        var dragpiece=null;
		var overlay_canvas=null;
		var undopiece=new Array();
		var undooffset=new Array();
		var redopiece=new Array();
		var redooffset=new Array();

	 	var initOverlay=function(){
			if(overlay_canvas==null){
	        	$("body").append("<canvas id='sw20_overlay' style='top:0;left:0;position:absolute;width100%;height:100%;'></canvas>");
				overlay_canvas=document.getElementById("sw20_overlay");
				overlay_canvas.width=$(overlay_canvas).innerWidth();
				overlay_canvas.height=$(overlay_canvas).innerHeight();
	        }
		}
		
		var isDogfightRange=function(from,to){
			var dx=Math.abs(from.left-to.left);
			var dy=Math.abs(from.top-to.top);
			var distance=Math.sqrt(Math.pow(dx,2)+Math.pow(dy,2));
			return (unit_size*3)>distance;
		}

	       /* 引数の初期値を設定（カンマ区切り） */
        initOverlay();
		var defaults={
			limitedMove:3,
			Move:14,
			active:false,
			border:"1px solid red",
			startX:null,
			startY:null,
			offset:$(this).offset(),
			Name:"NoName"
		}
		
		//引数で渡した設定値で初期化
		var conf=$.extend(defaults, params);
		//設定をデータにマッピング
		for(var key in conf){
			$(this).data(key,conf[key]);
		}


		// 一致した各要素ごとにバインドする必要のある処理は各要素ごとに繰り返す。
		this.each(function(i){
			function getConf(){
				return conf;
			}
			//コマはコマとして判定するためクラスを追加する。
			$(this).addClass('sw20piece');
			//移動の開始とマウスポインタが乗ったままの場合の移動の終了はオブジェクト自体で取る。
			$(this).mousedown(function(e){
				if(!$(this).data('active')){
					$(this).data('active',true);
					$(this).css("border",$(this).data('border'));
					if($(this).data('active')){
					$(this).data('startX',e.pageX);
					$(this).data('startY',e.pageY);
					$(this).data('offset',$(this).offset());
					dragpiece=$(this);
					//undoの上限数に達していたら一番古いものを捨てる。
					if(undopiece.length>=undo_count)undopiece.shift();
					if(undooffset.length>=undo_count)undooffset.shift();
					//undo用スタックに積む。
					undopiece.push($(this));
					undooffset.push($(this).offset());
					//doが発生した時点でredoは空になる。
					redopiece.length=0;
					redooffset.length=0;

					}
					//オーバレイに移動範囲を描画
					var ctx=overlay_canvas.getContext('2d');
					var limrange=$(this).data('limitedMove')*unit_size;
					var range=$(this).data('Move')*unit_size;
					var fullrange=$(this).data('Move')*unit_size*3;
					if(overlay_canvas&&ctx){
						ctx.strokeStyle = $(this).css("background-color");
						ctx.fillStyle = $(this).css("background-color");
						ctx.lineWidth=2;
						ctx.clearRect(0,0,$(overlay_canvas).innerWidth(),$(overlay_canvas).innerHeight());
						ctx.beginPath();
						ctx.arc($(this).attr("offsetWidth")/2+$(this).data('offset').left, $(this).attr("offsetHeight")/2+$(this).data('offset').top,limrange, 0, Math.PI*2, true);
						ctx.stroke();
						ctx.beginPath();
						ctx.arc($(this).attr("offsetWidth")/2+$(this).data('offset').left, $(this).attr("offsetHeight")/2+$(this).data('offset').top,fullrange, 0, Math.PI*2, true);
						ctx.stroke();
						ctx.beginPath();
						ctx.arc($(this).attr("offsetWidth")/2+$(this).data('offset').left, $(this).attr("offsetHeight")/2+$(this).data('offset').top,range, 0, Math.PI*2, true);
						ctx.stroke();
						ctx.fillText("制限移動\n"+$(this).data('limitedMove')+"m",$(this).attr("offsetWidth")/2+$(this).data('offset').left+limrange+5,$(this).attr("offsetHeight")/2+$(this).data('offset').top);
						ctx.fillText("通常移動\n"+$(this).data('Move')+"m",$(this).attr("offsetWidth")/2+$(this).data('offset').left+range+5,$(this).attr("offsetHeight")/2+$(this).data('offset').top);
						ctx.fillText("全力移動\n"+($(this).data('Move')*3)+"m",$(this).attr("offsetWidth")/2+$(this).data('offset').left+fullrange+5,$(this).attr("offsetHeight")/2+$(this).data('offset').top);
					}
				}
			});
		});
		
		//移動と移動の終了、キャンセルはマウスポインタが外れてもいいようにdocumentで取る。
		$(document).mousemove(function(e){
			if(dragpiece!=null){
				var range=e.shiftKey?dragpiece.data('limitedMove')*unit_size: dragpiece.data('Move')*unit_size;
				if(!e.shiftKey&&e.altKey){range*=3;}
				if(dragpiece.data('active')){
					var px=dragpiece.data('startX');var py=dragpiece.data('startY');
					var x=e.pageX;var y=e.pageY;
					var mx=x-px;var my=y-py;
					if(Math.sqrt(Math.pow(mx,2)+Math.pow(my,2))>range){
						var a=range/Math.sqrt(Math.pow(mx,2)+Math.pow(my,2));
						mx*=a;
						my*=a;
					}
					dragpiece.css({top:dragpiece.data('offset').top+my,left:dragpiece.data('offset').left+mx});
					//
				}
			}
		}).mouseup(function(e){
			if(dragpiece!=null){
				dragpiece.data('active',false);
				dragpiece.css("border","1px solid gray");
				dragpiece.data('startX',null);
				dragpiece.data('startY',null);
				dragpiece.data('offset',dragpiece.offset());
				var ctx=overlay_canvas.getContext('2d');
				if(overlay_canvas&&ctx){
					ctx.clearRect(0,0,$(overlay_canvas).innerWidth(),$(overlay_canvas).innerHeight());
				}
				//乱戦エリアの判定
				$('.sw20piece').each(function(){
					var tgt=new Array();
					if(dragpiece.data()!=$(this).data()){					
						if(isDogfightRange(dragpiece.offset(),$(this).offset())){
							tgt.push($(this));
						}
					}
					//移動側
					
					//受動側
					for(var t in tgt){
						alert($(this).data('Name')+">>"+dragpiece.data('Name'));
					}
				});
				dragpiece=null;
			}
		}).keypress(function(e){
			//alert(e.which);//キーコード確認用
			if(redopiece.length>0&&e.ctrlKey&&e.which==121){//redo:Ctrl+Y
				
				var tgt=redopiece.pop();
				var off=redooffset.pop();
				if(tgt&&off){
					//redoの上限数に達していたら一番古いものを捨てる。
					if(undopiece.length>=undo_count)undopiece.shift();
					if(undooffset.length>=undo_count)undooffset.shift();
					//redo用スタックに積む。
					undopiece.push(tgt);
					undooffset.push(tgt.offset());
					//undoを実行
					tgt.animate({top:off.top,left:off.left},"fast");
					$('#chk').html(undopiece.length+' '+redopiece.length);

				}
				
			}else if(undopiece.length>0&&e.ctrlKey&&e.which==122){//undo:Ctrl+Z
				var tgt=undopiece.pop();
				var off=undooffset.pop();
				if(tgt&&off){
					//redoの上限数に達していたら一番古いものを捨てる。
					if(redopiece.length>=undo_count)redopiece.shift();
					if(redooffset.length>=undo_count)redooffset.shift();
					//redo用スタックに積む。
					redopiece.push(tgt);
					redooffset.push(tgt.offset());
					//undoを実行
					tgt.animate({top:off.top,left:off.left},"fast");
					$('#chk').html(undopiece.length+' '+redopiece.length);

				}
			}

			});
        },
        method1 : function(params){
        	return conf[param];
        },
        method2 : function(params) {return this;}
    };
    
	$.fn['sw20piece'] = function(method) {
        if ( piecemethods[method] ) {
            return piecemethods[ method ]
                .apply( this, Array.prototype.slice.call( arguments, 1 ));
        } else if ( typeof method === 'object' || ! method ) {
            return methods.init.apply( this, arguments );
        } else {
            return this;
        }
    };
    //Google spleadsheetから読み込む
	$.fn.loadsw20piece=function(file,key,sheet,from,to){
		$.ss("http://spreadsheets.google.com/tq?key="+file+"&authkey="+key)
			//.setQuery("select * where B like 'test%'")
			.setField("name,color,icon,move,lim_move,max_move")
			.send(function(success){
				if(success){
				var pos=64;
				var table = $("#character table")
					.append(
						$("<tr />")
							.append($("<th />").text("名前"))
							.append($("<th />").text("背景色"))
							.append($("<th />").text("画像"))
							.append($("<th />").text("通常移動"))
							.append($("<th />").text("制限移動"))
							.append($("<th />").text("全力移動"))
					);
				this.each(function(i){
					//キャラクタータブの表に追加
					table.append($("<tr />")
							.append($("<th />").text(this.name))
							.append($("<td />").css("color",this.color).text(this.color))
							.append($("<td />").html("<img src='"+this.icon+"'>"))
							.append($("<td />").text(this.move))
							.append($("<td />").text(this.lim_move))
							.append($("<td />").text(this.max_move))
					);
					
					var chara=$("<div />");
					$('body').append(chara);
					chara.css({
						//生成される駒のCSSプロパティ
						left:128,
						top:pos,
						'background-color':this.color,
						'background-image':"url('"+this.icon+"')",
						'background-position':'center',
						'background-repeat':'no-repeat'
					}).sw20piece('init',{
						//生成される駒の動作関連プロパティ
						Move:this.move,
						limitedMove:this.lim_move,
						Name:this.name
					});
					pos+=64;
				});
				}else{
					alert("スプレッドシートの読み込みに失敗しました"+this["errors"].type);
				}
			})
		}
})(jQuery);